<?php

namespace SM\Controller;

use SM\Util\Utilities;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00005000TabParametrizacoesSignatariosPadroesService;
use SM\Traits\TResponse;

class Sm00005000TabParametrizacoesSignatariosPadroesController
{
    use TResponse;

    protected $parametrizacaoSignatariosService;

    public function __construct(Sm00005000TabParametrizacoesSignatariosPadroesService $parametrizacaoSignatariosService)
    {
        $this->parametrizacaoSignatariosService = $parametrizacaoSignatariosService;
    }

    public function getSignatariosPadroes()
    {
        try {
            $data = $this->parametrizacaoSignatariosService->getSignatariosPadroes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getParceriaOperador()
    {
        try {
            $data = $this->parametrizacaoSignatariosService->getParceriaOperador();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveSignatariosPadroes(Request $request)
    {
        try {
            $data = $this->parametrizacaoSignatariosService->saveSignatariosPadroes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteParametrosSignatario(Request $request)
    {
        try {
            $data = $this->parametrizacaoSignatariosService->deleteParametrosSignatario($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function cadAutoSignatPadr(Request $request)
    {
        try {
            $data = $this->parametrizacaoSignatariosService->cadAutoSignatPadr($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
