<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use \Teknisa\Model\Traits\TQuery;

class AgendaServicosFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getAgendaServicos($cdcliente, $nrproposfas, $nrverpropfas, $cdclienteC, $nrproposfasC, $nrverpropfasC, $nrcontratofct, $dtAgendamento)
    {
        $sqlAlter = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY'";
        $this->connection->executeStatement($sqlAlter);
    
        $sql = "SELECT  ROWNUM || '_' || C.CDTIPOSERV AS CDTIPOSERV, ROWNUM, T.NMTIPOSERV, C.CDCLIENTE, CL.NMFANTCLIE, C.NRPROPOSFAS, C.NRVERPROPFAS, P.DSREFEPROPOSFAS, C.NRSERVCONT, V.VRHORACLIE AS VRHORAPEDC, C.QTSERVCONT,
                        C.IDTIPOCOBRCONT AS IDVLRSERPEDC, C.DSLOCALCONT AS DSLOCALPEDC, P.IDLIBERAAGENDAMENTO, NVL(SM.QTHRAPROFATU,0) AS QTHRAPROFATU,
                        DECODE(C.IDTIPOCOBRCONT, 'P', 0, V.VRDEHORACLIE) AS VRDEHORAPEDC, DECODE(C.IDTIPOCOBRCONT, 'P', 0, V.VRHORACLIE) AS VALOR,
                        (V.VRHORACLIE - V.VRDEHORACLIE) AS DESCONTO, P.IDTIPOPROPFAS, HORADEC_HORACHAR(NVL(SM.QTHRDESLOC,0)) AS QTHRDESLOC,
                        HORADEC_HORACHAR(NVL(SM.QTHRSERVPREST,0)) AS QTHRSERVPREST, HORADEC_HORACHAR(NVL(SM.QTHRAPROFATU,0)) AS QTHRSERVFATU,
                        HORADEC_HORACHAR(NVL(SM.QTHRNFATUR,0)) AS QTHRNFATUR, HORADEC_HORACHAR(NVL((C.QTSERVCONT - (NVL(SM.QTHRAPROFATU,0))),0)) AS SALDO,
                        HORADEC_HORACHAR(C.QTSERVCONT) AS QTSERVPEDC, CT.NRCONTRATOFCT, CT.NRSEQCONTRATO, C.USR_DTAGENDZERASALDO, C.USR_QTSERVCONT_BKP, C.NRPROPOSFAS||'-'||P.NRVERPROPFAS AS NRPROPOSTA
                FROM VALORSERV V,
                        (SELECT NRPROPOSFAS, NRVERPROPFAS, CDTIPOSERV, NRSERVCONT, NRORG, SUM(HORACHAR_HORADEC(QTHRTOTAL)) AS QTHRSERVPREST,
                                SUM(HORACHAR_HORADEC(QTHRDESLOCAMENTOFAT)) AS QTHRDESLOC, SUM(NVL(QTHRAPROFATU, 0)) AS QTHRAPROFATU,
                                SUM(HORACHAR_HORADEC(QTHRTOTAL) - HORACHAR_HORADEC(QTHRATIVIDADEFAT)) AS QTHRNFATUR
                        FROM SERVPREST
                        WHERE 1 = 1
                            $cdcliente
                            $nrproposfas
                            $nrverpropfas
                        GROUP BY NRPROPOSFAS, NRVERPROPFAS, CDTIPOSERV, NRSERVCONT, NRORG) SM,
                        (SELECT NRPROPOSFAS, NRVERPROPFAS, NRSERVCONT, CDTIPOSERV, NRORG, MAX(DTIVIGVRSERV) AS DATAINI
                        FROM VALORSERV
                        WHERE 1 = 1 
                            $nrproposfas
                            $nrverpropfas
                        GROUP BY NRPROPOSFAS, NRVERPROPFAS, NRSERVCONT, CDTIPOSERV, NRORG) MD,
                        TIPOSERV T,
                        PROPOSTAFAS P,
                        CONTRATOSERV C,
                        FCT_CONTRATO CT,
                        CLIENTE CL
                WHERE 1 = 1 
                    AND C.QTSERVCONT IS NOT NULL
                    AND P.NRPROPOSFAS = C.NRPROPOSFAS
                    AND P.NRVERPROPFAS = C.NRVERPROPFAS
                    AND P.NRORG = C.NRORG
                    AND T.CDTIPOSERV = C.CDTIPOSERV
                    AND T.NRORG = C.NRORG
                    AND MD.NRPROPOSFAS = C.NRPROPOSFAS
                    AND MD.NRVERPROPFAS = C.NRVERPROPFAS
                    AND MD.NRSERVCONT = C.NRSERVCONT
                    AND MD.CDTIPOSERV = C.CDTIPOSERV
                    AND MD.NRORG = C.NRORG
                    AND SM.NRPROPOSFAS (+) = C.NRPROPOSFAS
                    AND SM.NRVERPROPFAS (+) = C.NRVERPROPFAS
                    AND SM.CDTIPOSERV (+) = C.CDTIPOSERV
                    AND SM.NRSERVCONT (+) = C.NRSERVCONT
                    AND SM.NRORG (+) = C.NRORG
                    AND (SM.QTHRAPROFATU > 0 OR C.DTCONTSERVRESC IS NULL)
                    AND V.NRPROPOSFAS = MD.NRPROPOSFAS
                    AND V.NRVERPROPFAS = MD.NRVERPROPFAS
                    AND V.NRSERVCONT = MD.NRSERVCONT
                    AND V.CDTIPOSERV = MD.CDTIPOSERV
                    AND V.NRORG = MD.NRORG
                    AND V.DTIVIGVRSERV = MD.DATAINI
                    AND CT.NRSEQCONTRATO(+) = P.NRSEQCONTRATO
                    AND CL.CDCLIENTE = C.CDCLIENTE
                    $cdclienteC
                    $nrproposfasC
                    $nrverpropfasC
                    $nrcontratofct
                    $dtAgendamento";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getCliente()
    {
        $sql = "SELECT DISTINCT C.CDCLIENTE, C.NRINSJURCLIE, C.NMFANTCLIE, C.NMRAZSOCCLIE, C.IDLIBGERPER,
                (C.NRINSJURCLIE||' - '||C.NMFANTCLIE) AS NMCLIENTE
                FROM CLIENTE C, CONTRATOSERV CS
                WHERE (C.CDCLIENTE = CS.CDCLIENTE)
                ORDER BY C.NMFANTCLIE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getPropostaAgendaServicos($params)
    {
        $sql = "SELECT DISTINCT CS.NRPROPOSFAS,  CS.NRVERPROPFAS, PR.NRCONTATO, CT.DSREFECONT,  CS.NRPROPOSFAS || ' - ' || CS.NRVERPROPFAS || ': ' || PR.DSREFEPROPOSFAS as DSREFEPROPOSFAS,
                        CS.NRPROPOSFAS || ' - ' || CS.NRVERPROPFAS AS PROPOSTA
                FROM PROPOSTAFAS PR, CONTATO CT, CONTRATOSERV CS
                WHERE CS.NRPROPOSFAS = PR.NRPROPOSFAS
                    AND CS.NRVERPROPFAS = PR.NRVERPROPFAS
                    AND CS.NRORG = PR.NRORG
                    AND PR.CDFILIAL = CT.CDFILIAL(+)
                    AND PR.NRCONTATO = CT.NRCONTATO(+)
                    AND PR.NRORG     = CT.NRORG(+)
                    AND CS.CDCLIENTE IN ($params)
                ORDER BY CT.DSREFECONT, CS.NRPROPOSFAS, CS.NRVERPROPFAS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function updatebkpContratoServ(array $params)
    {
        $sql = "UPDATE CONTRATOSERV
                   SET USR_QTSERVCONT_BKP     = NVL(HORACHAR_HORADEC(:USR_QTSERVCONT_BKP), :USR_QTSERVCONT_BKP),
                       DTULTATU               = SYSDATE,
                       CDOPERULTATU           = :CDOPERULTATU,
                       NRORG                  = :NRORG
                 WHERE CDTIPOSERV = :CDTIPOSERV AND CDCLIENTE = :CDCLIENTE AND NRPROPOSFAS = :NRPROPOSFAS
                 AND NRVERPROPFAS = :NRVERPROPFAS";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateSaldoContratoServ(array $params)
    {
        $sql = "UPDATE CONTRATOSERV
                   SET USR_DTAGENDZERASALDO   = :USR_DTAGENDZERASALDO,
                       QTSERVCONT             = :QTSERVCONT,
                       DTULTATU               = SYSDATE,
                       CDOPERULTATU           = :CDOPERULTATU,
                       NRORG                  = :NRORG
                 WHERE CDTIPOSERV = :CDTIPOSERV AND CDCLIENTE = :CDCLIENTE AND NRPROPOSFAS = :NRPROPOSFAS
                 AND NRVERPROPFAS = :NRVERPROPFAS";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateDataContratoServ(array $params)
    {
        $sql = "UPDATE CONTRATOSERV
                   SET USR_DTAGENDZERASALDO   = :USR_DTAGENDZERASALDO,
                       DTULTATU               = SYSDATE,
                       CDOPERULTATU           = :CDOPERULTATU,
                       NRORG                  = :NRORG
                 WHERE CDTIPOSERV = :CDTIPOSERV AND CDCLIENTE = :CDCLIENTE AND NRPROPOSFAS = :NRPROPOSFAS
                 AND NRVERPROPFAS = :NRVERPROPFAS";

        $this->connection->executeStatement($sql, $params);
    }

    public function reverterSaldoHoras(array $params)
    {
        $sql = "UPDATE CONTRATOSERV
                   SET USR_QTSERVCONT_BKP     = :USR_QTSERVCONT_BKP,
                       USR_DTAGENDZERASALDO   = :USR_DTAGENDZERASALDO,
                       DTULTATU               = SYSDATE,
                       CDOPERULTATU           = :CDOPERULTATU,
                       NRORG                  = :NRORG
                 WHERE CDTIPOSERV = :CDTIPOSERV AND CDCLIENTE = :CDCLIENTE AND NRPROPOSFAS = :NRPROPOSFAS
                 AND NRVERPROPFAS = :NRVERPROPFAS";

        $this->connection->executeStatement($sql, $params);
    }

    public function reverterSaldoHorasBkp(array $params)
    {
        $sql = "UPDATE CONTRATOSERV
                   SET QTSERVCONT             = :QTSERVCONT,
                       DTULTATU               = SYSDATE,
                       CDOPERULTATU           = :CDOPERULTATU,
                       NRORG                  = :NRORG
                 WHERE CDTIPOSERV = :CDTIPOSERV AND CDCLIENTE = :CDCLIENTE AND NRPROPOSFAS = :NRPROPOSFAS
                 AND NRVERPROPFAS = :NRVERPROPFAS";

        $this->connection->executeStatement($sql, $params);
    }

    public function getPropostasAgendadas(array $params)
    {
        $sql = "SELECT USR_DTAGENDZERASALDO, QTSERVCONT, CDTIPOSERV, CDCLIENTE, NRPROPOSFAS, NRVERPROPFAS, NRSERVCONT,
                USR_QTSERVCONT_BKP
                FROM CONTRATOSERV
                WHERE TO_CHAR(USR_DTAGENDZERASALDO, 'DD/MM/YYYY') = TO_CHAR(SYSDATE, 'DD/MM/YYYY') AND NRORG = :NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getNomeOperador(array $params)
    {
        $sql = "SELECT NMOPERADOR
                FROM OPERADOR
                WHERE CDOPERADOR = :CDOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getLogAgendaServicos(array $params)
    {
        $sql = "SELECT DTOPERACAO, NMRESPOPER, DSOPERACAO, CDPESQITEM
                FROM LOGOPERA
                WHERE NMTABELA = 'CONTRATOSERV' AND CDPESQITEM = :CDPESQITEM";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function insertLogOpera(array $params)
    {
        $sql = "INSERT INTO LOGOPERA (
            NMTABELA,           DTOPERACAO,      NMRESPOPER,
            CDORESPOPER,        IDTIPOOPER,      DSNMUSUOPER,
            DSMETUSUOPER,       DSOPERACAO,      CDPESQITEM,         
            DTINCLUSAO
        )
        VALUES (
            :NMTABELA,          SYSDATE,             :NMRESPOPER,
            :CDORESPOPER,       :IDTIPOOPER,         :DSNMUSUOPER,
            :DSMETUSUOPER,      :DSOPERACAO,       :CDPESQITEM,        
            SYSDATE       
        )";
        $this->connection->executeStatement($sql, $params);
    }
}
