/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NUTR                                                     */
/* Tabela : NUTRIENTE                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_NUTR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_NUTR
GO

CREATE TRIGGER DTULTATU_NUTR
ON NUTRIENTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'NUTRIENTE', null, 'CDNUTRIENTE='+ CDNUTRIENTE+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE NUTRIENTE
      SET DTULTATUNUTR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(NUTRIENTE.CDNUTRIENTE,0) = ISNULL(INSERTED.CDNUTRIENTE,0)) AND
            (ISNULL(NUTRIENTE.NMNUTRIENTE,0) = ISNULL(INSERTED.NMNUTRIENTE,0)) AND
            (ISNULL(NUTRIENTE.SGUNIDADE  ,0) = ISNULL(INSERTED.SGUNIDADE  ,0)) AND
            (ISNULL(NUTRIENTE.NMREDUZIDO ,0) = ISNULL(INSERTED.NMREDUZIDO ,0));
   END;
END;
GO

